=== src/gpu/amd/CMakeLists.txt ===
#===============================================================================
# Copyright 2022-2023 Intel Corporation
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#===============================================================================

file(GLOB_RECURSE SOURCES
    ${CMAKE_CURRENT_SOURCE_DIR}/*.hpp
    ${CMAKE_CURRENT_SOURCE_DIR}/*.cpp)

set(OBJ_LIB ${LIB_PACKAGE_NAME}_sycl_amd)
add_library(${OBJ_LIB} OBJECT ${SOURCES})


set_target_properties(${OBJ_LIB} PROPERTIES COMPILE_DEFINITIONS "$<TARGET_PROPERTY:rocBLAS::rocBLAS,INTERFACE_COMPILE_DEFINITIONS>;$<TARGET_PROPERTY:MIOpen::MIOpen,INTERFACE_COMPILE_DEFINITIONS>"
        COMPILE_OPTIONS "$<TARGET_PROPERTY:rocBLAS::rocBLAS,INTERFACE_COMPILE_OPTIONS>;$<TARGET_PROPERTY:MIOpen::MIOpen,INTERFACE_COMPILE_OPTIONS>")

target_include_directories(${OBJ_LIB} PRIVATE $<TARGET_PROPERTY:MIOpen::MIOpen,INTERFACE_INCLUDE_DIRECTORIES> $<TARGET_PROPERTY:rocBLAS::rocBLAS,INTERFACE_INCLUDE_DIRECTORIES>)

add_library(${OBJ_LIB}_interface INTERFACE)
target_link_libraries(${OBJ_LIB}_interface INTERFACE rocBLAS::rocBLAS MIOpen::MIOpen)
set_property(GLOBAL APPEND PROPERTY DNNL_LIB_DEPS $<TARGET_OBJECTS:${OBJ_LIB}>)

set(${LIB_PACKAGE_NAME}_INTERFACE ${${LIB_PACKAGE_NAME}_INTERFACE} ${OBJ_LIB}_interface PARENT_SCOPE)
